// cdg merge tool

//struct CDG_DATA
typedef struct 
	{
	DWORD number_tracks;
	char	cue_path[MAX_PATH];

	DWORD disk_bytecnt;
	DWORD reserved1;
	DWORD reserved2;
	DWORD reserved3;
	DWORD reserved4;
	DWORD reserved5;

	struct
		{
		DWORD	number;
		DWORD	length;
		DWORD	samples_per_second;
		DWORD	bits_per_sample;
		DWORD	number_channels;
		DWORD	scms;
		DWORD	startd_id;
		char	pcm_path[MAX_PATH];
		char	cdg_path[MAX_PATH];
		char	raw_path[MAX_PATH];
		} track[110];

} CDG_DATA, *_cdg_data;

/*
// example cue file
track 1 
	audio	c:\temp\t1.wav
	data	c:\temp\t1.cdg
	startid	0
	scms	00
track 2
	audio	c:\temp\t2.wav
	data	c:\temp\t2.cdg
	startid	0
	scms	10
track 3 
	audio	c:\temp\t3.wav
	data	c:\temp\t3.cdg
	startid	0
	scms	10
track 4 
	audio	c:\temp\t4.wav
	data	c:\temp\t4.cdg
	startid	0
	scms	10
*/


int parse_cue(CDG_DATA *cdg_data)
{
FILE cue_in;


return(0);
}

// this is a routine that needs to be written that will make up the .cue file needed
// by goldenhawk's cdrwin program to do the burn based on all the files that are 
// going to be put on the cd
int make_cdrwin_cue(CDG_DATA *cdg_data)
{
int i;


return(0);
}


__declspec( dllexport ) void find_track_length (CDR_DATA *cdr_data, int i)
{
AnalyzerInfo info;
int          status, j;
void        *analyzer;
char		buffer [100];
unsigned	long byte_per_sec;
DWORD		Res;

	eprintf("track %d %s is: ",i, cdr_data->track[i].path);
	// grab the file type extension from a string
	j = strlen(cdr_data->track[i].path) - 1;
	while ((j>0)&&(cdr_data->track[i].path[j] != '.'))
		j--;
	if ( (j>0)&& (j<(int)strlen(cdr_data->track[i].path)) )
		strcpy(buffer, &cdr_data->track[i].path[j+1]);
	else
		strcpy(buffer, "");
	buffer[3] = 0;
//	eprintf("track %d is %s\n",i, buffer);
	cdr_data->track[i].length = 0;
	// if the file type is mpeg audio then use xaudio analyzer to find real length
	if	((strcmp(strupr(buffer),"MP3") == 0) || 
		 (strcmp(strupr(buffer),"MP2") == 0) || 
		 (strcmp(strupr(buffer),"MPA") == 0) )
		{
		eprintf("mpx\n");		
		status = xanalyzer_new(&analyzer);
		if (status) 
			{
			eprintf("cannot create analyzer (%d)\n", status);
			}
		else
			{
			int		watchdog	= 131072;	// Max number of bytes to read in, to protect against corrupted files
			int		max_frames	= 32;		// Max number of frames to analyze
			status = xanalyzer_process_file(analyzer, (LPSTR) cdr_data->track[i].path, &info, 0, watchdog, max_frames);

			// try the quick method first, if you still can't find the file, search the whole file.
			if (XANALYZE_ERROR_WATCHDOG == nret)
			{
				status = xanalyzer_process_file(analyzer, (LPSTR) cdr_data->track[i].path, &info, 0, 0 /* watchdog */, 0 /* max_frames */);
			}

			if (status) 
				{
				eprintf("cannot analyze file (%d)\n", status);
				}
			else
				{
//			    eprintf("DURATION  = %ld.%ld secs\n", 
//					info.duration/1000,
//					info.duration%1000);
				cdr_data->track[i].samples_per_second = info.stream_type.frequency;
				cdr_data->track[i].bits_per_sample = 16;
				cdr_data->track[i].number_channels = info.stream_type.channels;

				eprintf("channels %d, samp-per-sec %d, bit-rate %d\n",
					info.stream_type.channels,
					info.stream_type.frequency,
					info.stream_type.bitrate);
				// check that the number of channels is 2, frequency is 44.1 

				// time is giving in ms and there are 176.4 bytes per ms in 44.1khz 
				// also round up to the next whole frame boundary
				// can we assume that the decoder will automatically do sample rate conversion so that
				// output is guaranteed to be 44.1/16/2?  if so then do calc with these values instead
				// of the ones found by xanalyze
				byte_per_sec = 2 * info.stream_type.channels * info.stream_type.frequency;
//				cdr_data->track[i].length =  DWORD( (LONG(info.duration)*LONG(byte_per_sec/100)+5L)/10L );
				cdr_data->track[i].length =  DWORD( (LONG(info.duration)*1764L+5L)/10L );
				eprintf("chunk size %ld\n", cdr_data->track[i].length);
				/* delete the analyze object */
				}
			}	
		xanalyzer_delete(analyzer);
		} // end if type is mpx
	// if the file type is wav then use the mmio functions to find the real length.
	else if (strcmp(strupr(buffer),"WAV") == 0)
		{
		eprintf("wav\n");		
		// Declare the structures we'll need.
		MMCKINFO ChunkInfo;
		MMCKINFO SubChunkInfo;
		MMCKINFO FormatChunkInfo;
		WAVEFORMATEX WaveFormat;
                     
		// Zero out the ChunkInfo structure.
		memset(&ChunkInfo, 0, sizeof(MMCKINFO));
		//	Open the file.
		HMMIO handle = mmioOpen(cdr_data->track[i].path, 0, MMIO_READ);
		if (!handle) 
			{
			//MessageBox(0, "Error opening file.", "Error Message", 0);  
			//return;
			}
		else
			{
			// Find the RIFF chunk.
			Res = mmioDescend(handle, &ChunkInfo, 0, MMIO_FINDRIFF);   
			if (Res != 0)
				{
				// can't find the riff chunk
				}
			else
				{
				// Descend into the format chunk.
				FormatChunkInfo.ckid = mmioStringToFOURCC("fmt", 0);  
				Res = mmioDescend(handle, &FormatChunkInfo, &ChunkInfo, MMIO_FINDCHUNK);   
				if (Res != 0)
					{
					// can't find the format chunk
					}
                else
					{
					// Read the format chunk
					memset(&WaveFormat, 0, sizeof(WAVEFORMATEX));
					// mmioRead and mmioWrite return the number of bytes read or
					// written so don't call the CheckMMIOError fucntion for those.   
					Res = mmioRead(handle, (char*)&WaveFormat, FormatChunkInfo.cksize);

					if (Res > 0)
						{
						// make sure the file is 44.1, 16 bit, 2 channel
						eprintf("channels %d, samp-per-sec %d, bit-per-samp %d\n",
						WaveFormat.nChannels,
						WaveFormat.nSamplesPerSec,
						WaveFormat.wBitsPerSample);

						cdr_data->track[i].samples_per_second = WaveFormat.nSamplesPerSec;
						cdr_data->track[i].bits_per_sample = WaveFormat.wBitsPerSample;
						cdr_data->track[i].number_channels = WaveFormat.nChannels;

						// Find the data subchunk
						SubChunkInfo.ckid = mmioStringToFOURCC("data", 0);
						Res = mmioDescend(handle, &SubChunkInfo, &ChunkInfo, MMIO_FINDCHUNK);

						if (Res != 0)
							{
							// can't find the data chunk
							eprintf("can't find data chunk\n");
							}
						else
							{		
							cdr_data->track[i].length = DWORD( (LONG(SubChunkInfo.cksize)*10L+5L)/10L );
							eprintf("chunk size %ld\n", SubChunkInfo.cksize);
							//DWORD           cksize;         /* chunk size */
							//DWORD           dwDataOffset;   /* offset of data portion of chunk */
							}                     
						} // end if more than 0 bytes returned by mmioread
					} // end if found format chunk
				} // end if found riff chunk
			} // end if mmio open ok
		// Close the file
		mmioClose(handle, 0);
		} // end if wav format
	else
		{
		//unknown track type

		}

// start counting the bytes per track for one big total
cdr_data->disk_bytecnt += cdr_data->track[i].length;
// if pregap is turned on then add an extra 2 seconds
if (cdr_data->pregap == TRUE)
	cdr_data->disk_bytecnt += 150;

}


DWORD lba2msf(DWORD lba)
{
DWORD msf;
DWORD min, sec, frame;

min = (lba+150)/60/75;
sec = (lba+150-min*60*75)/75;
frame = (lba+150-min*60*75-sec*75);

msf = (min<16)|(sec<8)|(frame);
return(msf);
}

DWORD msf2lba(DWORD msf)
{
DWORD lba;
DWORD min, sec, frame;

min = (lba>16)&0xff;
sec = (lba>8)&0xff;
frame = lba&0xff;

lba = min*60*75 + sec*75 + frame - 150;
return(lba);
}


int next_cdg_position(HMMIO cdg_handle, long cdg_position, long track_position)
{
long checking_position;
char cdg_buf[24];
int more_checking;

//SEEK_SET = 0  '  seek to an absolute position
//SEEK_CUR = 1  '  seek relative to current position
//SEEK_END = 2  '  seek relative to end of file	

checking_position = cdg_position;
more_checking = TRUE;

while (more_checking)
	{
	// get 1 cdg pack
	if ((read_len = mmioRead( cdg_handle, cdg_buf, 24)) != 24 )
		{
		// must be the end of the file
		more_checking = FALSE;
		}
	else
		{
		if (0 == msf2lba((buf[20]<<16)&(buf[21]<8)&buf[22])
			{
			// the pack position is defined as null
			// this means that the pack can go anywhere
			more_checking = FALSE;
			}
		else if ((track_position/2352) == msf2lba((buf[20]<<16)&(buf[21]<8)&buf[22])
			{
			// the track position matches the pack position
			// this means that the pack has to go right here
			more_checking = FALSE;
			}
		else if ((track_position/2352) > msf2lba((buf[20]<<16)&(buf[21]<8)&buf[22])
			{
			// the track position is later than the pack
			// this means that the pack is supposed to have gone already - this is a problem?
			}
		else
			{
			// the track position is earlier than the pack
			// this means that the pack isn't needed until later so don't use it now
			}
		}

	checking_position += read_len;
	}

// seek back to where it was before hunting for some absolute position packs
mmioSeek( cdg_handle, cdg_position, SEEK_SET);
	
// if next cdg pack location matches the track position
return(TRUE);
// otherwise say false which means putting in a dummy pack
return(FALSE);

}


int cdg_merge(CDG_DATA *cdg_data)
{
long cdg_position;
long track_position;
FILE cdg_in, pcm_in, raw_out;
int i;
MMCKINFO ChunkInfo;
char pcm_buf[2352];
char cdg_buf[96];
char raw_buf[2352+96];
HMMIO pcm_handle, cdg_handle, raw_handle;


(for i=0;i<cdg_data->number_tracks;i++)
	{
	// open wav file or mp3 file

	// Zero out the ChunkInfo structure.
	memset(&ChunkInfo, 0, sizeof(MMCKINFO));
	//	Open the file.
	pcm_handle = mmioOpen(cdg_data->track[i].pcm_path, 0, MMIO_READ);
	if (!pcm_handle) 
		{
		//MessageBox(0, "Error opening file.", "Error Message", 0);  
		return(-1);
		}
	else
		{
		// Find the RIFF chunk.
//		Res = mmioDescend(handle, &ChunkInfo, 0, MMIO_FINDRIFF);   
		FormatChunkInfo.ckid = mmioStringToFOURCC("data", 0);  
		Res = mmioDescend(handle, &FormatChunkInfo, &ChunkInfo, MMIO_FINDCHUNK);   
		if (Res != 0)
			{
			// can't find the data chunk
			return(-2);
			}
		else
			{
			} // end if mmio open ok
		}		

	cdg_handle = mmioOpen(cdg_data->track[i].cdg_path, 0, MMIO_READ);
	if (!cdg_handle) 
		{
		//MessageBox(0, "Error opening file.", "Error Message", 0);  
		return(-1);
		}
	else
		{

		}
	
	raw_handle = mmioOpen(cdg_data->track[i].cdg_path, 0, MMIO_WRITE);
	if (!raw_handle) 
		{
		//MessageBox(0, "Error opening file.", "Error Message", 0);  
		return(-1);
		}
	else
		{

		}
	
	track_position = 0;
	cdg_position = 0;
	audio_data_remaining = TRUE;

	// get a frame (2352 bytes) of audio data
	if ((read_len = mmioRead( pcm_handle, pcm_buf, 2352)) != 2352 )
		{
		// must be the end of the file
		// nul out the 2352-read_len bytes at end of buf

		audio_data_remaining = FALSE;
		}
	track_position += read_len;

	// get 4 cdg packs
	if ((read_len = mmioRead( cdg_handle, cdg_buf, 96)) != 96 )
		{
		// must be the end of the file
		// nul out the 96-read_len bytes at end of buf

		audio_data_remaining = FALSE;
		}
	cdg_position += read_len;

	while (audio_data_remaining)
		{
		// merge the packs

		// decide if cdg pack matches with the position of pcm data
		// otherwise put in a filler nul pack
		if (next_cdg_position(cdg_handle, cdg_position, track_position))
			{
			// put in the pack data from disk
			}
		else
			{
			// put in a nul pack of data
			}

		// write the data

		// get a frame (2352 bytes) of audio data

		// get 4 cdg packs

		}


	// pad out audio data to a round 2352 bytes

	// close the files
	mmioClose(handle, 0);

	} // end for i to number of tracks

return(TRUE);
}
